#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "xmlclient4xi.py">
#<abstract4xi abstract = "provides xml client"/>
#<refer4xi reference = "connection.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "XmlClient4Xi compared to XmlClient of connection.py and found no changes due to Rel 7.21"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'XmlClient4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import errno
import io
import itertools
import os
import pickle
import select
import socket
import struct
import sys
import time
import tempfile
try:
    import _winapi
    from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE
except ImportError:
    if sys.platform == 'win32':
        raise
    _winapi = None
    
import hmac    
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing import connection
try:                             # Python ones
    from multiprocessing.connection import XmlClient 
except:
    print("xmlclient4xi.py *** failed in from multiprocessing.connection import XmlClient ***") 
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from client4xi import Client4Xi
from connectionwrapper4xi import ConnectionWrapper4Xi
import xmllistener4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi Globals                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global xmlrpclib4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "listener_client4xi.py" usage = "
# listener_client4xi = {'pickle' : (Listener4Xi, Client4Xi),'xmlrpclib' : (XmlListener4Xi, XmlClient4Xi)}
#">
# -------------------------------------------------------------------------------------------------
def XmlClient4Xi(*args, **kwds):
    '''
    XmlClient4Xi function returns with (*args, **kwds)
    
    '''
    global xmlrpclib4xi
    
    class2print = "XmlClient4Xi"
    method2print = "XmlClient4Xi"


    message2print = "{started" + "; XmlClient4Xi-started: " + str(XmlClient4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------     
    ack2import = False
    nack2import = True
        
    try:
        import xmlrpc.client as xmlrpclib4xi #<-- defined by xmllistener4xi.py module
        
        ack2import = True
        
        message2print = "{set" + "; ack2import-set-by-XmlClient4Xi to: " + str(ack2import)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    

        message2print = "{passing" + "; Client4Xi-passing-to-ConnectionWrapper4Xi-by-XmlClient4Xi: " + str(Client4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                
        message2print = "{returning" + "; ConnectionWrapper4Xi-class-returning-by-XmlClient4Xi: " + str(ConnectionWrapper4Xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 

        return ConnectionWrapper4Xi(Client4Xi(*args, **kwds), _xml_dumps, _xml_loads)

    except:
        message2print = "{yielded" + "; nack2import-yielded-by-XmlClient4Xi: " + str(nack2import)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
    
    
        return XmlClient(*args, **kwds)
            
        
#</function4xi> 
#</program4xi>

     

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-none4xi.xml
#   reason-none4xi.xml
#   ace-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of xmlclient4xi.py                       
# ------------------------------------------------------------------------------------------------- 
#"
